const bel = require('bel')
const csjs = require('csjs-inject')
const logo = require('play-logo')

module.exports = menubar

// theme = {
//   "font1":"Courier New",
//   "color_text":"#8a929b",
//   "color_activeText":"#ffffff",
//   "color_bgPanel":"#2c323c",
//   "color_bgTab":"#21252b",
//   "color_bgContent":"#21252b",
//   "color_background":"#8a929b",
//   "color_bgPane":"#21252b",
//   "color_bgMenubar":"#21252b",
//   "logo":[
//     "hsla(120.21219456537133,100%,15%,1)",
//     "hsla(98.73088246205019,100%,15%,1)",
//     "hsla(62.31218931761149,100%,15%,1)"
//   ],
//   "color_bgEditor":"#21252b",
//   "color_bgLinebar":"#21252b",
//   "color_seperator":"#2c323c"
// }
// var items = [ // e.g.
//   { title: 'asdf', fn: e => console.log('cmd:asdf') },
//   { title: 'rstu', fn: e => console.log('cmd:rstu') },
//   { title: 'xyz!', fn: e => console.log('cmd:xyz!') },
//   { title: 'opq!', fn: e => console.log('cmd:opq!') }
// ]
// var el = menubar({ items, theme })

function menubar ({ items = [], theme = {} }, emit) {
  const css = getTheme(theme)
  const logoEl = logo({ urls: [], colors: theme.logo || [
    `hsla(${360*Math.random()},100%,60%,1)`,
    `hsla(${360*Math.random()},100%,60%,1)`,
    `hsla(${360*Math.random()},100%,60%,1)`,
  ] })
  return bel`
    <div class=${css.menubar}>
      <div class=${css.navbar}>
      ${items.map(({ active, title, fn }) => bel`
        <button class="${css.btn} ${active ? css.active : ''}" onclick=${e => {
          var buttons = [...e.currentTarget.parentElement.children]
          buttons.forEach(btn => {
            if (btn === e.currentTarget) btn.classList.add(css.active)
            else btn.classList.remove(css.active)
          })
          fn()
        }}>${title}</button>
      `)}
      </div>
      <div class=${css.logo}>${logoEl}</div>
    </div>`
}
const getTheme = (THEMES => (theme, key = JSON.stringify(theme)) =>{
  return THEMES.get(key) || THEMES.set(key, style(theme)).get(key)
}
)(new Map([]))
// @TODO: maybe use "WeakMap" instead? ...and init on first use?
const style = ({
  // @TODO: map to meaningful names
  // @TODO: make updatable (dark->light->dark->...)
  color_bgPanel,
  color_background,
  color_bgMenubar,
} = {}) => csjs`
.navbar {
  display: flex;
  flex-direction: row;
  box-sizing: border-box;
  margin: 0;
  align-items: center;
  padding: 7px;
  padding-left: 20px;
  flex-grow: 1;
}
.btn {
  margin: 0 2px;
  background-color: ${color_bgPanel};
  border: 4px solid ${color_bgPanel};
}
.active {
  background-color: ${color_background};
}
.logo {
  width: 50px;
  height: 45px;
  margin-right: 10px;
}
.menubar {
  box-sizing: border-box;
  display: flex;
  flex-direction: row;
  width: 100%;
  justify-content: space-between;
  align-items: stretch;
  padding: 5px;
  background-color: ${color_bgMenubar};
  overflow: hidden;
}`
